<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_ServiceCategory ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_ServiceCategory extends AbstractStructArrayBase
{
    /**
     * The ServiceCategory
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_ServiceCategory[]
     */
    public $ServiceCategory;
    /**
     * Constructor method for ArrayOfJP_ServiceCategory
     * @uses ArrayOfJP_ServiceCategory::setServiceCategory()
     * @param \StructType\JP_ServiceCategory[] $serviceCategory
     */
    public function __construct(array $serviceCategory = array())
    {
        $this
            ->setServiceCategory($serviceCategory);
    }
    /**
     * Get ServiceCategory value
     * @return \StructType\JP_ServiceCategory[]|null
     */
    public function getServiceCategory()
    {
        return $this->ServiceCategory;
    }
    /**
     * Set ServiceCategory value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ServiceCategory[] $serviceCategory
     * @return \ArrayType\ArrayOfJP_ServiceCategory
     */
    public function setServiceCategory(array $serviceCategory = array())
    {
        foreach ($serviceCategory as $arrayOfJP_ServiceCategoryServiceCategoryItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_ServiceCategoryServiceCategoryItem instanceof \StructType\JP_ServiceCategory) {
                throw new \InvalidArgumentException(sprintf('The ServiceCategory property can only contain items of \StructType\JP_ServiceCategory, "%s" given', is_object($arrayOfJP_ServiceCategoryServiceCategoryItem) ? get_class($arrayOfJP_ServiceCategoryServiceCategoryItem) : gettype($arrayOfJP_ServiceCategoryServiceCategoryItem)), __LINE__);
            }
        }
        $this->ServiceCategory = $serviceCategory;
        return $this;
    }
    /**
     * Add item to ServiceCategory value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ServiceCategory $item
     * @return \ArrayType\ArrayOfJP_ServiceCategory
     */
    public function addToServiceCategory(\StructType\JP_ServiceCategory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_ServiceCategory) {
            throw new \InvalidArgumentException(sprintf('The ServiceCategory property can only contain items of \StructType\JP_ServiceCategory, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ServiceCategory[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_ServiceCategory|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_ServiceCategory|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_ServiceCategory|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_ServiceCategory|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_ServiceCategory|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ServiceCategory
     */
    public function getAttributeName()
    {
        return 'ServiceCategory';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_ServiceCategory
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
